/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-31 17:24
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 2e5 + 5;
ll N;

void solve(){
    // Code goes here ...
    cin >> N;
    vector<int>a(N);
    R(i, N)
        cin >> a[i];

    bool strictasc = 1, strictdesc = 0;
    int seqlen = 0, last = a[0], cur, acc = 0;
    int triv = 0;
    bool asc = 1;
    int changes = 0;
    F(i, 1, N){
        cur = a[i];
        if(last == cur)
            triv++;

        if(last < cur){
            if(asc){
            }
            else{
                asc = 1;
                changes++;
            }
            /* if(strictasc) */
            /*     seqlen++; */
            /* else{ */
            /*     strictasc = 1; */
            /*     acc += seqlen; */
            /*     seqlen = 1; */
            /* } */
            /* strictdesc = 0; */
        }
        if(last > cur){
            if(asc){
                asc = 0;
                changes++;
            }
            else{
            }
        }
        /* if(last > cur){ */
        /*     if(strictdesc) */
        /*         seqlen++; */
        /*     else{ */
        /*         strictdesc = 1; */
        /*         acc += seqlen; */
        /*         seqlen = 1; */
        /*     } */
        /*     strictasc = 0; */
        /* } */
        /* if(last == cur){ */
        /*     strictdesc = strictasc = 0; */
        /*     acc += seqlen; */
        /*     seqlen = 0; */
        /* } */
        last = cur;
    }
    int res;
    if(strictasc and seqlen == N-1)
        res = 0;
    else{
        /* res = (N-1) - acc; */
        res = triv + (changes + 1) / 2 ;
    }
    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
